package fr.sanchezm.attestationsCovid19.data.db.dao

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import com.google.gson.Gson
import fr.sanchezm.attestationsCovid19.data.db.entity.Profile
import java.io.File

class ProfileDao(private val path: String) {

    private val _profile = MutableLiveData<Profile>()
    private val fileName = "profile.db"

    fun getProfile(): LiveData<Profile> =
        _profile

    fun updateProfile(profile: Profile) {
        _profile.value = profile
        save()
    }

    init {
        load()
    }

    private fun load() {
        val file = File("$path/$fileName")

        if (file.exists()) {
            _profile.value = Gson().fromJson(file.readText(Charsets.UTF_8), Profile::class.java)
        } else {
            _profile.value = Profile("", "", "", "", "", "", "")
        }
    }

    private fun save() {
        File("$path/$fileName").writeText(Gson().toJson(_profile.value))
    }
}

//@Dao
//interface ProfileDao {
//    @Insert(onConflict = OnConflictStrategy.REPLACE)
//    fun insert(profile: Profile)
//
//    @Query(value = "SELECT * FROM profile WHERE id = $CURRENT_PROFILE_ID")
//    fun getProfile(): LiveData<Profile>
//}
